"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Enumeration = void 0;
class Enumeration {
    constructor(_value) {
        this._value = _value;
    }
    get value() {
        return this._value;
    }
    static parse(value) {
        return Enumeration.getAll().find((instance) => instance.value === value);
    }
    static getAll() {
        const enumClass = this;
        const properties = Object.getOwnPropertyNames(enumClass.prototype);
        return properties
            .map((name) => enumClass[name])
            .filter((value) => value instanceof enumClass);
    }
    static getAllValues() {
        const allInstances = this.getAll();
        return allInstances.map((instance) => instance.value);
    }
}
exports.Enumeration = Enumeration;
